/*
 * ADCKeyboard.cpp
 *
 *  Created on: 10 сент. 2016 г.
 *      Author: alexandr
 */


#include "Utils.h"
#include "Config.h"
#include "ADCKeyboard.h"


#define ADC_COUNT_MAX			600


ADCKeyboard adcKeyboard;


static volatile ADC_KEY adcOldKey = ADC_KEY::KEY_INIT;
static volatile uint16_t adcCount = 0;

ISR(ADC_vect)
{
	ADC_KEY adcKey;
	uint8_t adcData = ADCL;
	adcData = ADCH;

	if (adcData > 210) {
		adcKey = ADC_KEY::KEY_CANCEL;
	} else if (adcData > 150) {
		adcKey = ADC_KEY::KEY_OK;
	} else if (adcData > 90) {
		adcKey = ADC_KEY::KEY_DOWN;
	} else if (adcData > 30) {
		adcKey = ADC_KEY::KEY_UP;
	} else {
		adcKey = ADC_KEY::KEY_INIT;
	}
	if ((adcKey != ADC_KEY::KEY_INIT)
			&& (adcKey == adcOldKey)) {
		adcCount++;
	} else {
		adcCount = 0;
	}
	if (adcCount > ADC_COUNT_MAX) {
		adcKeyboard.putKeyData(adcKey);
		adcCount = 0;
	}
	adcOldKey = adcKey;
}


ADCKeyboard::ADCKeyboard()
{
	writeIndex = -1;
	readIndex = -1;
}

ADCKeyboard::~ADCKeyboard()
{
}

void ADCKeyboard::enable()
{
	START_CS
	ADMUX = (1 << ADLAR) | (1 << MUX1);
	ADCSRB = 0x00;
	ADCSRA = (1 << ADEN) | (1 << ADSC) | (1 << ADATE) | (1 << ADIF) | (1 << ADIE)
					| (1 << ADPS2) | (1 << ADPS1) | (1 << ADPS0);
	END_CS
}

bool ADCKeyboard::isKeyDataAvailable() {
	return readIndex != writeIndex;
}

ADC_KEY ADCKeyboard::getKeyData() {
	readIndex = (readIndex + 1) % KEY_BUFFER_LENGTH;
	return buffer[readIndex];
}

void ADCKeyboard::putKeyData(ADC_KEY keyData) {
	writeIndex = (writeIndex + 1) % KEY_BUFFER_LENGTH;
	buffer[writeIndex] = keyData;
}


