/*
 * ADCKeyboard.h
 *
 *  Created on: 10 сент. 2016 г.
 *      Author: alexandr
 */

#ifndef ADCKEYBOARD_H_
#define ADCKEYBOARD_H_

#include <avr/interrupt.h>


#define KEY_BUFFER_LENGTH	8

enum ADC_KEY
{
	KEY_INIT,
	KEY_UP,
	KEY_DOWN,
	KEY_OK,
	KEY_CANCEL
};

class ADCKeyboard {
public:
	ADCKeyboard();
	~ADCKeyboard();

	void enable();
//	void disable();

	bool isKeyDataAvailable();
	ADC_KEY getKeyData();
	void putKeyData(ADC_KEY keyData);

private:
	int8_t writeIndex;
	int8_t readIndex;
	ADC_KEY buffer[KEY_BUFFER_LENGTH];
};


extern ADCKeyboard adcKeyboard;

#endif /* ADCKEYBOARD_H_ */
