/*
 * Message.cpp
 *
 *  Created on: 10 сент. 2016 г.
 *      Author: alexandr
 */

#include <avr/pgmspace.h>
#include <avr/eeprom.h>

#include "LCD3WI.h"
#include "Utils.h"

#include "Message.h"


const char engineMessageEn[] PROGMEM = "Engine";
const char engineMessageRu[] PROGMEM = "Установка";

const char presetMessageEn[] PROGMEM = "Preset";
const char presetMessageRu[] PROGMEM = "Предуст.";

const char timeMessageEn[] PROGMEM = "Time";
const char timeMessageRu[] PROGMEM = "Время";

const char ledsMessageEn[] PROGMEM = "LEDs";
const char ledsMessageRu[] PROGMEM = "УФ";

const char onMessageEn[] PROGMEM = "on";
const char onMessageRu[] PROGMEM = "вкл.";

const char offMessageEn[] PROGMEM = "off";
const char offMessageRu[] PROGMEM = "выкл.";

const char settingsMessageEn[] PROGMEM = "Settings";
const char settingsMessageRu[] PROGMEM = "Настройки";

const char languageMessageEn[] PROGMEM = "Languauge";
const char languageMessageRu[] PROGMEM = "Язык";

const char englishMessageEn[] PROGMEM = "English";
const char englishMessageRu[] PROGMEM = "English";

const char russianMessageEn[] PROGMEM = "Русский";
const char russianMessageRu[] PROGMEM = "Русский";

const char delayMessageEn[] PROGMEM = "Delay";
const char delayMessageRu[] PROGMEM = "Задержка";

const char saveMessageEn[] PROGMEM = "Save";
const char saveMessageRu[] PROGMEM = "Сохранить";

const char startMessageEn[] PROGMEM = "Start";
const char startMessageRu[] PROGMEM = "Старт";

const char * const messages[13][2] PROGMEM =
{
		{engineMessageEn, engineMessageRu},
		{presetMessageEn, presetMessageRu},
		{timeMessageEn, timeMessageRu},
		{ledsMessageEn, ledsMessageRu},
		{onMessageEn, onMessageRu},
		{offMessageEn, offMessageRu},
		{settingsMessageEn, settingsMessageRu},
		{languageMessageEn, languageMessageRu},
		{englishMessageEn, englishMessageRu},
		{russianMessageEn, russianMessageRu},
		{delayMessageEn, delayMessageRu},
		{saveMessageEn, saveMessageRu},
		{startMessageEn, startMessageRu}
};


extern uint8_t language;


Message::Message() {
}

Message::~Message() {
}

void Message::getMessage(MessageCodes code, char *buffer, size_t size) {
	const char * msg = (const char *) pgm_read_word(&messages[code][language]);
	strncpy_P(buffer, msg, size);
}

size_t Message::getMessageSize(MessageCodes code)
{
	const char * msg = (const char *) pgm_read_word(&messages[code][language]);
	size_t result = strlen_P(msg);
	if (language) {
		result >>= 1;
	}
	return result;
}
